module G2R
  module Neo4J
    class Connection
      def initialize(options)
        @conn = Neography::Rest.new(options)
      end

      def query_columns(cypher)
        columns = Set.new
        query(cypher)['data'].each do |row|
          columns += row[0]['data'].keys
        end

        columns.to_a
      end

      def query_data(cypher)
        query(cypher)['data']
      end

      def query_hash(cypher)
        results = query(cypher)
        results["data"].map {|row| Hash[*results["columns"].zip(row).flatten] }
      end

      def query(cypher)        
        @conn.execute_query(cypher)
      end
    end
  end
end
