module G2R
  module RDBMS
    class Connection

      def initialize(options)
        # sequel
        @db = Sequel.connect(options)
      end

      def create_table(table)
        @db.create_table! table.name.to_sym do

          table.columns.each do |column|
            # primary key
            if column.primary_key?
              primary_key column.name.to_sym
            # foreign key
            elsif column.foreign_key?
              foreign_key column.name.to_sym, column.target_table.to_sym
              index column.name.to_sym
            # common column
            else
              String column.name.to_sym
            end
          end
        end
      end

      def insert_data(table)
         @db.transaction do
           table.data.each do |row|
             @db[table.name.to_sym].insert(row)
           end
         end
      end

    end
  end
end
