module G2R
  module RDBMS

    class JoinTable < Table

      def initialize(source_table, relationship, target_table)
        # parent initialization
        super("")

        # additiional initialization
        table_name = "#{source_table}_#{relationship}_#{target_table}"
        @name = RDBMS.transform_name(table_name)

        @source_table = RDBMS.transform_name(source_table)
        @target_table = RDBMS.transform_name(target_table)
      end

      # Additionally return the source and target column ids plus all defined columns
      def columns
        [source_column, target_column] + super
      end

      def source_column
        Column.new(source_table + "_id").foreign_key(source_table)
      end

      def target_column
        if source_table != target_table
          Column.new(target_table + "_id").foreign_key(target_table)
        else
          Column.new(target_table + "_id_2").foreign_key(target_table)
        end
      end

      # ==========================================================================
      # ACESSORS
      # ==========================================================================
      def source_table
        @source_table
      end

      def target_table
        @target_table
      end
    end
  end
end
