module G2R
  module RDBMS
    class Table

      def initialize(name)
        @name = RDBMS.transform_name(name)
        @columns = []
        @data = []
      end

      def ==(other_table)
        @name == other_table.name
      end

      def name
        @name
      end

      def add_columns(columns)
        # transform string into array
        if columns.class != Array
          columns = [columns]
        end

        # filter out columns that already exists
        columns = columns.map do |column|
          if @columns.include? column
            nil
          else
            column
          end
        end.compact

        # append columns
        @columns += columns
      end

      def columns
        @columns
      end

      def add_data(data)
        @data += data
      end

      def data
        @data
      end
    end
  end
end
